/**
  (c) Copyright CERN 2005. All rights not expressly granted are reserved.
  icecontrols.support@cern.ch

  SPDX-License-Identifier: LGPL-3.0-only
**/

// #uses "classes/unTree/deviceParsers/unTreeDeviceParser.ctl"
#uses "classes/unTree/deviceParsers/unTreeDeviceParserPanel.ctl"
#uses "classes/unTree/deviceParsers/unTreeDeviceParserPlot.ctl"
#uses "classes/unTree/deviceParsers/unTreeDeviceParserPage.ctl"
// #uses "fwException.ctl"

class UnTreeDeviceParserFactory{

    public static shared_ptr<UnTreeDeviceParser> createDeviceParser(
        anytype device,
        shared_ptr<UnTreeProcessContext> context = nullptr,
        string deviceType = ""
    ){
        if(deviceType == ""){
            FwException::assertDP(device,"","Non existing dp: " + device);
            deviceType = dpTypeName(device);
        }
        switch(deviceType){
            // case "FwTreeNode":
            //     return new UnTreeDeviceParser(device,context);
            case "_UnPanel":
                return new UnTreeDeviceParserPanel(device,context);
            case "FwTrendingPage":
                return new UnTreeDeviceParserPage(device,context);
            case "FwTrendingPlot":
                return new UnTreeDeviceParserPlot(device,context);
            case "FwTrending_Plot":
            case "FwTrending_Page":
                return new UnTreeDeviceParser(device,context);
            default:
                FwException::raise("Cannot create instance of DeviceParser - unsupported type: " + deviceType);
        }
    }
};
