/**
  (c) Copyright CERN 2005. All rights not expressly granted are reserved.
icecontrols.support@cern.ch

  SPDX-License-Identifier: LGPL-3.0-only
**/

#uses "classes/fwTrending/FwTrending_TrendContainer.ctl"

class UnTrending_PlotContainer : FwTrending_PlotContainer{
  public UnTrending_PlotContainer(shared_ptr<FwTrending_TrendDataA> plotData, bool checkData = true) : FwTrending_PlotContainer(plotData, checkData) {
        if(checkData && !plotData.isPlot()){
            FwException::raise("Invalid trend data, plot expected");
        }
  }

  public void openInHmi(string deviceName){
    openTrendInHmi(deviceName, visualizationPanelFile(), toDollarParams());
  }
  
};

class UnTrending_PageContainer : FwTrending_PageContainer{

  public UnTrending_PageContainer(shared_ptr<FwTrending_TrendDataA> pageData, bool checkData = true) :
          FwTrending_PageContainer(pageData,  checkData){
        if(checkData && !pageData.isPage()){
            FwException::raise("Invalid trend data, page expected");
        }
    }

  public shape openInHmi( string deviceName){
    openTrendInHmi(deviceName, visualizationPanelFile(), toDollarParams());
  }
};


void openTrendInHmi(string deviceName, string sPanelFileName, string sDollarParam){
  if (globalExists("g_unHMI_RunsInNewHMI")) {
    shape mainWindow = getShape(UNHMI_MAIN_MODULE_NAME + "." + UNHMI_MAIN_PANEL_NAME + ":");
    int currentModule = mainWindow.unHMI_getCurrentModule();
    if ((currentModule >=1) && (currentModule <= UNHMI_MAX_NUMBER_OF_PREVIEW_MODULES)) {
      unHMI_openPreviewModuleHelper(sPanelFileName, currentModule, sDollarParam);
    }  else {
      for (int i=1; i<=UNHMI_MAX_NUMBER_OF_PREVIEW_MODULES; i++) {
        if (mainWindow.unHMI_getIsPreviewModuleOpen(i)){
          unHMI_openPreviewModuleHelper(sPanelFileName, i, sDollarParam);
          break;
        }
      }
    }
    
  } else {
    string buttonPanel="";
    dyn_string exInfo;
    unGraphicalFrame_showUserPanel(sPanelFileName, sDollarParam, deviceName);
    unGenericDpFunctions_getContextPanel(deviceName, buttonPanel, exInfo);
    if(buttonPanel != "")
      unGraphicalFrame_showContextualPanel(buttonPanel, deviceName);
  }
}
